Granite Suite of Import Converters - Main Table of Contents

"PTC Granite" Suite of CAD Import Converters

Quick Jump:

Visual snapshot index of each import converter panel

Introduction

This help file describes the PTC Granite suite of CAD import converters. These importers allow geometry, hierarchy, materials and attributes (from part and/or assembly data) to be imported from a wide range of standard BREP solids-based CAD file formats, and then subsequently optimized, re-exported or rendered with Okino's PolyTrans, NuGraf, PolyTrans-for-Cinema-4D, PolyTrans-for-3dsMax or PolyTrans-for-Maya software, or any number of third party OEM programs which integrate Okino software.

Granite is an interoperability platform based on the geometry, feature and data exchange capabilities at the core of PTC's Creo Elements/Pro (a.k.a Pro/Engineer), a market leading mechanical computer-aided design software.

See Also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Features of the PTC Granite Suite of Import Conversion System

Converter File Format Comparisons & Info

Visual Snapshot Index of Each Import Converter Panel

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files", their Usage & Family Tables

The File Import Process Using Okino’s PolyTrans or NuGraf

Supported CAD Import File Formats

The suite of importers supported by this PTC Granite system includes these formats:

Import File Format | File Extensions
Creo Elements/Pro Parts & Assembly (a.k.a Pro/Engineer) | .asm, .prt, .neu, .xpr, .xas
ACIS SAT | .sat
Creo Elements/View (PTC ProductView) | .pvs, .pvz, .edz, .ed, .ol
IGES | .iges, .igs, .ige
PARASOLID | .xmt, .xmt_txt, .xmt_bin, .xmt_neu, .x_t, .x_b, .x_n
PTC "g-plugs" | .g
STEP assemblies (AP203 and AP214) | .stp, .step, .ste

Note: the general preference order for using these importers is: ProE/Creo (when ProE/Creo files are available), STEP solids, IGES solids, PARASOLID and then ACIS.

When coming from SolidWorks, use Okino’s native SolidWorks importer to read in the .sldasm and .sldprt files. However, if you don’t own SolidWorks and wish to control the mesh density (the overall polygon count) then use "IGES solids" files exported from within SolidWorks as follows:

- Press "Reset" to ensure the start-up IGES options are chosen

- Change the top combo box to "Manifold Solid (type 186)"

- Disable the "Flatten assembly hierarchy" checkbox

When coming from UniGraphics NX, always use STEP AP214 and not PARASOLID format.

When coming from Solid Edge, use Okino’s native Solid Edge importer or STEP AP214 format (you’ll have to enable the AP214 checkbox on the Solid Edge STEP exporter).

When coming from Autodesk Inventor, always use Okino’s native Inventor importer, or equally, Okino’s DWF-3D importer – both work very well. Otherwise, you can choose between IGES solids and STEP solids export from Inventor.

NOTES:

1. If you perceive that not all of your parts are being imported then please ensure that the "Import Quilts" option is enabled, and "Make Quilts Hidden" option is disabled on the Expert Geometry Processing wizard panel.

2. "ProE/Creo Parts & Assembly" is the natural native file format supported by Granite since Granite is a derivative of the ProE/Creo software itself. You will want to import the top-level ".asm" (assembly) or any single ".prt" (part) file. You can also open up ProE/Creo assembly (.xas) and part (.xpr) accelerator files.

3. To import data from ProE/Crep, Okino recommends either the native Granite ProE/Creo native importer (as per above in the table), ProE/Creo .neutral files, PTC STEP or PTC IGES.

4. Family table of instances in ProE/Creo files: if your part files use instances in family tables then you must explicitly create instance accelerator files to go along with those instances in the family tables. This is fully described in this section.

o NOTE: if you cannot acquire the instance accelerator files (.xas and .xpr) then enable the "Load facet data when accelerator files are not found" checkbox option on the Okino ProE/Creo importer wizard ("expert" mode). You can also, alternatively, enable the "Load generic models (when no instance accelerator files found)" checkbox option – this later option causes the generic model to be loaded instead of the proper derived instance of that generic model.

5. STEP AP203 allows users to exchange geometry, topology and configuration data of a part or the whole product assembly. The user can exchange wireframe models, surface models and boundary representation of exact or faceted three-dimensional solids. STEP AP214 is a super set of AP-203 to define core data for automotive mechanical design processes.

6. An 'assembly' file organizes one or more 'part' files into a more complex object. If your dataset consists of a main assembly file and multiple part files, then always just import the main assembly file (.asm).

7. If there are multiple versions of a part file on disk (such as .prt.1, prt.2, .prt.3) then the newest part will always be opened (.prt.3).

Graniteâ , Pro/ENGINEERâ, Creoâ and Pro/DESKTOPâ are registered trademarks of PTC Corporation. ACISâ and SATâ are registered trademarks of Spatial Corp. PARASOLIDâ is a registered trademark of Siemens Corp. 3ds Maxâ, Mayaâ and Softimageâ are registered trademarks of Autodesk. All other brand names, product names or trademarks belong to their respective holders.


Visual Snapshot Index of Each Import Converter Panel

Click below for help on any import converter panel:

Intro Panel | Beginner/Expert Mode | Beginner Precision
Expert NURBS Surfaces & Curves | Expert Tessellation Precision | Expert Geometry Processing

Expert Geometry Processing # 2 | ProE Asembly File Processing Options | Material Import

Material Tweaks | Measurement Units, Hierarchy Optimization & Meta-Data | Statistics, Runtime Error Reporting & Finish


Features of the PTC Granite Import Conversion System

Features & Overview of the "PTC Granite" Suite of Import Converters

Overview

Okino has actively integrated the PTC Granite interoperability kernel directly into its PolyTrans & NuGraf packages to provide extensive "3D solids" model import support to its already extensive line up of 3D CAD and non-CAD file formats. PTC Granite's modeling code uses the exact same geometry libraries as ProE/Creo, the most robust solid modeler in the world.

This core technology adds the strong native file import support for ACIS SAT, Creo Elements/View (PTC ProductView), IGES (from solids), PTC Pro/ENGINEER (Creo Elements/Pro), PARASOLID and STEP. These formats play a pivotal role in bridging the CAD and industrial design markets with the non-CAD worlds of 3D multi-media animation packages, VisSim packages, WEB publishing and polygonal modelers via the tied-and-tested Okino data translation pipelines offered in the PolyTrans & NuGraf packages.

Features

· Adds a wealth of complementary 3D-solids-based file formats (ACIS SAT, Creo Elements/View, IGES, PARASOLID, ProE/Creo and STEP), at a very affordable cost, to the already extensive list of Okino supported CAD file formats (including).

· Import all of the Granite file formats directly into 3ds Max (via PolyTrans-for-3dsMax) or Maya (via PolyTrans-for-Maya) via native plug-in versions of PolyTrans, or use the stand-alone PolyTrans/NuGraf software to re-export the Granite-imported data to all major 3D file formats in an optimized state.

· A highly developed and continually maintained importer by Okino. In addition, Okino has tested the Granite converters with a huge selective of CAD data from the Okino 3D model repository and has used this data to help PTC refine all of their import converters. This is a highly refined and robust set of CAD importers which we are very proud to support.

· Imports and retains: assembly hierarchy information, assembly names, BREP structure of the source model (bodies and faces), various material parameters, model units and units matching, and various attributes (hidden status).

· The quality of the model (the number of polygons) can be controlled via surface deviation, curve deviation and normal (angle) deviation controls.

· Optional import of the trimmed NURBS representation of the model with uv-space trim curves, optimized and processed via the PTC Granite "GPI" engine.

· Import of independent NURBS curves, including composite and sketch curves. Not all downstream file formats and programs will be able to handle such curves, but Okino's internal 2D curves engine will allow them to be re-exported to many formats or programs as NURBS curves, bicubic curves, polylines or line segments.

· Direct access to PTC Granite model processing functionality: (i) Apply data healing algorithms, (ii) Close open boundaries and, (iii) Simplify surfaces.

· Okino's "CAD Scene and Hierarchy Optimization System" has been integrated right into the Granite importer. This is most important when importing large CAD models into 3ds Max, Maya or Lightwave. These animation packages tend to have performance problems when the source CAD model is large, and/or has a large number of individual parts (which is often the case with the BREP model topology of data provided by the Granite importers).

· A good number of options that can be (optionally) set prior to import, to control most situations that could be encountered with Granite data import.

· Complete control over material parameter modification on an automatic basis. Many CAD systems have basic material parameters (like color, ambient + diffuse shading coefficients, opacity, etc) but when they are transferred over to a rendering and animation system they often look "too bright" or "highly ambient". This can be expected and is quite normal. The material tweak parameters easily allow such saturated shading values to be automatically compensated.

· Importing via a "solids-based" file format ensures that adjacent NURBS patches are "stitched" together via topology information (BREP data) and thus creates "crack free" tessellation when the NURBS or parametric solids are converted to a polygonal mesh.

· Intelligent support for importing PTC ProE/Creo part and assembly accelerator files (.xpr and .xas).

See Also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

Converter File Format Comparisons & Info

Important Runtime Information, How-To’s, and Execution Notes

The File Import Process Using Okino’s PolyTrans or NuGraf

ProE/Creo "Instance Accelerator Files" and their Usage


Converter Comparisons, Converter Info and PTC Support Policy

Converter File Format Comparisons & Info

Okino, and in particular our CTO Robert Lansdale, has long been an advocate of teaching and helping our customers to best understand how to perform proper CAD to non-CAD file format conversions. Magazines, product reviews, industry columns, mailing lists and advertising has sometimes left wrong impressions with such people about which file formats to use for proper data conversion.

The following paragraphs are to provide an overview of each of the Granite supported 3D file formats.

Explanations of the Various Granite Supported 3D File Formats

STEP File Format

STEP (which is short for STandard for the Exchange of Product model data and is also known as ISO 10303) is a standards-enabled technology for manufacturing developed by the International Organization for Standardization (ISO) to improve the exchange of data to meet a variety of industrial needs. This data includes design solids, product structure, product management and kinematics.

STEP AP203 and AP214 (which are supported in the Granite STEP importer) allow organizations to exchange 3-D solid and surface geometry between heterogeneous CAD systems. These two APIs can exchange a complete assembly of parts together with configuration management data and more, instead of just a single part.

STEP AP203 allows users to exchange geometry, topology and configuration data of a part or the whole product assembly. The user can exchange surface models and boundary representation of exact or faceted three-dimensional solids.

STEP AP214 is a super set of AP-203 to define core data for automotive mechanical design processes.

In the past, during the 1990’s and early 2000’s, Okino would always recommend "IGES solids" over STEP files. However, in this day and age, both transfer files fine form most source MCAD programs. However, STEP files are known to work best with Solid Edge and UG NX, whereas IGES solids is the best alternative format to export from SolidWorks. For Solid Edge, enable the "AP214" checkbox on their STEP exporter (do not use PARASOLID .x_t format from Solid Edge).

IGES

IGES, or the Initial Graphics Exchange Specifications, is by far one of the most openly accepted and implemented neutral file formats used to transfer CAD data between dissimilar modeling programs and applications. The file format specification is over 300 pages and over 1" thick; however, most IGES files only use a subset of the full specification.

It is a very common misconception amongst 3D users that "IGES does not provide for good data transfers". Okino has been one of the longest standing IGES developers (since 1988) and we know that this perception is quite incorrect. IGES files will always provide for ideal and error free conversions. The general perception of "bad data transfers" has come about by the multitude of destination programs which poorly implement the import of IGES (and other MCAD) file formats. We would consider IGES and STEP to be mirror twins of each other, providing for the same level of high quality conversion. In raw terms, all MCAD file formats transfer the exact same NURBS geometry data, although some people (due to lack of knowledge of 3D file formats) believe that one file format is somehow magically different or better than the others, such that IGES has lesser capabilities than STEP or PARASOLID --- this is just not the case for BREP solids and trimmed NURBS conversions. Magazine editors often stir up this discontent simply to spur readers to buy their magazines, creating "file format conversion wars" where no such wars exist.

We consider there to be 3 main types of IGES files:

· "Trimmed" surfaces. These IGES files use the 144/142/128 entities to define 3D objects defined by uv-space trimmed NURBS surfaces. Okino's IGES importer has been tailored specifically to this very common variation of the IGES spec.

· "Bounded" surfaces. These IGES files use the 143/141/128 entities to define 3D entities by bounded regions of world-space curves on surfaces. This form of IGES was more common prior to the 144/142/128 entities being added to the IGES spec, and in general this variation is less common today.

· "BREP" or "solids" surfaces. These IGES files use the 186 and 500 range of entities to define 3D entities as BREPs (body, shell, face, loop, edge and vertices). This is the standard for transferring "solids" data from one solids modeler to another, and the core of the Granite importers.

PARASOLID

PARASOLID is a common, popular and well established 3D solids modeling toolkit from Siemens Corp. It forms the basis, or is used, with many 3D MCAD solids modelers, including Microstation, Unigraphics/NX, SolidWorks and Solid Edge. The native file format is the PARASOLID ".x_t" format. From our day to day experience, we would always recommend using STEP AP214 first before using PARASOLID – this is because PARASOLID is an "evolving" file format that uses "schemas" to change the format monthly to yearly, whereas STEP is a "static" file format that can be guaranteed to import and translate properly without further interpretation.

ACIS SAT

"SAT" is the native ASCII based file format of the industry standard "ACIS" 3D solids modeling toolkit developed by Spatial Corp. Programs which are based upon the ACIS 3D solids modeling toolkit will naturally import and export this file format. Many of the example SAT files openly found on the Internet have versions between 3.0 and 7.0, although much newer versions of the ACIS 3D modeling toolkit, and hence the SAT file format, do exist.

In realistic terms, it would be VERY rare if and when a SAT file had to be imported. The usage of SAT files is not common in this day and age.

The following is a portion of a .sat file for illustrative purposes. Note that SAT file version number on the second line.

300 0 2 0

7 Unknown 11 ACIS 3.0 NT 24 Wed Mar 08 13:30:14 2003

cone-surface $-1 -2.5 45 45 -1 0 0 0 5.53554 5.574 1 0 1 0 #

colour-attrib $-1 $-1 $-1 $66 7 #

face $118 $119 $120 $6 $-1 $121 reversed single #

loop $-1 $-1 $122 $66 #

sphere-surface $-1 -65 -20 -20 20 1 0 0 0 0 1 0 #

coedge $-1 $91 $91 $123 $124 1 $67 $-1 #

coedge $-1 $92 $92 $69 $93 0 $125 $-1 #

edge $-1 $126 $126 $92 $127 0 #

loop $-1 $125 $70 $59 #

vertex $-1 $71 $128 #

ellipse-curve $-1 -25 -50 -30 0 1 0 0 0 15 1 #

point $-1 13 -50 16.771243444677 #

colour-attrib $-1 $-1 $-1 $77 1 #

face $129 $130 $131 $6 $-1 $132 forward single #

loop $-1 $-1 $133 $77 #


Runtime Suggestions

This short section explains the most fundamental and important suggestions that we pass on to users of the Granite suite of CAD importers. Taking into account these suggestions will make your usage of the software highly efficient. This section is accessible by pressing the "Suggestions…" hyperlink found on some of the importer wizard panels.

General Suggestions

· Always choose the "Expert Mode" so that you can control all the options discussed above.

Topology Units: "Bodies" vs "Faces" Suggestions

· For the most memory efficient and fastest imports, always use "Bodies". Each CAD "part" will be imported as one body object, and possibly one additional "quilt" object. This mode will also allow for crack-free mesh creation, whereas the "Faces" mode will not. This is the default option.

· Sometimes materials will be assigned to the "face level" in the CAD model and not the "body" level. In such cases, enable the "Faces" radio button and always make sure the "Enable Hierarchy Optimization" option is enabled on the last importer panel. "Faces" import mode can be memory inefficient and slow because each CAD "part" will be imported as many individual objects, each object corresponding to one NURBS surface from the original CAD part. Also, crack-free mesh creation cannot be provided since each NURBS surface is imported independently of each other.

"Hierarchy Optimization" Suggestions

· This is absolutely the most important option to keep enabled in most cases. It can make all the difference between importing a CAD model quickly, with little memory usage and the fewest objects verse importing it slowly, with all memory being used up, and with an excessive number of objects. This is particularly true if the Topology radio buttons are set to "Faces". This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders. It can have profound results, in particular, for CAD models imported into 3ds Max, Maya, Cinema-4D, Softimage and Lightwave. This option is not enabled during NURBS surface import since it would otherwise convert all the NURBS to polygons during the collapse process.

Scaling of the Model Suggestions

· Model scaling is an important, yet often overlooked aspect of the CAD import process by our users.

· In a nutshell, you should make sure your imported model generally ranges from 1x1x1 to 1000x1000x1000 units in size. Often we see customers importing a model which is only 0.001 units across - most downstream programs do not have the accuracy to display, render or manipulate such small models. Ditto on the model being too large (e.g. 1 million units wide).

· After your first file import use the destination program to determine the overall width, height and depth of the model, in general scaling terms. This can often be done by moving the cursor across the model and watching the current "XYZ Location" status bar message. If the model is too large, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 0.1, 0.01 or 0.001 (10x, 100x and 1000x times smaller). If the model is too small, re-import it and change the "Additional Scaling To Apply" type-in box to a number such as 10, 100 or 1000 (10x, 100x and 1000x times larger).

Tessellation Slider Suggestions

· Keep them to default values for most models you import. The default values statistically produce good results on typical models. If tiny round holes or fine fillets show up ragged, then enable the "Angular" checkbox and move the slider close to the "Fine" left-side location.

· If you’d like a higher quality dataset, with more polygons and less faceting, then you’d change the Planar and Curve sliders to 0.05% or even 0.01%. It would be rare if you needed to go any lower than these values. If you do, you can hand-enter lower numbers into the type-in boxes (such as 0.001%).

"Import of Quilts" Suggestions

· In general terms, the "Import Quilts " checkbox should be disabled for ProE/Creo file imports and enabled for all other types of import (ACIS, IGES, PARASOLID and STEP). Quilts are the portion of a BREP solids model which could not be sewn back together into the "solid" part of the "body" model (in other words, quilts hold the loose, independent NURBS surfaces).

NURBS vs. Polygons Suggestions

· Almost all users of this importer will want to use the "Polygons" import radio button. It will use the PTC Granite solids modeling kernel to tessellate the BREP solids model to a highly accurate and crack free model. This is basically what you are paying the money for and how you can be ensured a high quality model conversion.

· Choosing the "NURBS Surface" radio button is only to be used by those users who need to re-export the model to a file format or program which can accept NURBS surfaces with uv-space trim curves. For example, that could be Maya, IGES, JT, OpenNURBS (Rhino) or Softimage.

See also:

Main Index Page of This Online Help System


Important Runtime Information, How-To’s, and Execution Notes

· Why Does the Progress Bar Stop at 23% For A Long Time?

This is the point after import of the file when the PTC Granite kernel is stitching all the independent NURBS surfaces back into ProE/Creo-tolerant BREP solids and perform data tessellation. See the "Importing data is slow" section below which talks about this operation. It is not something that can be disabled or removed from the import process. The stitching will only occur if Granite determines that the source data is not in an ideal state or does not have topology information. By stitching the data together, the Granite kernel can create crack-free tessellated polygonal meshes, or create more mathematically clean NURBS surfaces.

· I see extraneous objects in the imported scene (or, some objects are missing). What is wrong?

Given our experiences with the Granite suite of converters, this can only be due to the "Import Quilts" option on the Expert Geometry Processing panel. A "quilt" is another name for a NURBS or spline surface imported from the source CAD file which was not used (stitched together) to form a BREP solids object. Some CAD files benefit from showing the quilt objects, which others do not. The checkbox should be disabled for ProE/Creo file imports and enabled for all other types of import (ACIS, IGES, PARASOLID and STEP).

If you see extraneous objects then try to import with "Import Quilts" disabled. If you don't see some expected objects then make sure this option is enabled.

Also, make sure "Back Face Culling" is disabled in your destination program, or make sure "Force 2 Sided" is enabled in 3ds Max. This can cause portions of a model to appear to be missing when it fact they are just culled out of the scene during runtime rendering.

· Importing data is slow. How can I speed it up?

There is no one absolute answer to this question because it depends highly on the data source, its contents, its size and its topology. Statistically, based on our bell curved usage of the Okino Granite importer, most file imports should finish within a few minutes, or a maximum of 5 to 15mins for really large datasets. If you should run out of memory, then the slowness is often attributable to the Windows memory page swapping to disk.

In general, make sure that your source CAD files were exported as "BREP solids" and not "Surfaced NURBS", so that stitching does not need to happen. Most imports should take only a few minutes if the data is in BREP solids format.

In many cases the PTC Granite kernel will try to "stitch" together disjoint 3D NURBS patches back into a BREP "solid" after the parsing of the source file is completed (be it IGES, STEP, PARASOLID, etc). For example, a car door might actually be composed of several hundred NURBS surfaces, yet ideally should be interpreted and considered as "one solid BREP surface". By stitching the NURBS patches together, crack-free tessellation can occur when the BREPs are converted to a triangular mesh. This process of stitching patches together can be a very time consuming process.

In our experience, the only slow imports we’ve encountered are for models with hundreds to thousands of trimming curves on a single NURBS surfaces, such as a fan grate with many tiny holes. This would not represent the typical models seen and imported each day.

Again, there is no one answer to this question. But here are various common suggestions:

· For the most memory efficient and fastest imports, always use the "Bodies" topology radio button. Each CAD "part" will be imported as one body object, and possibly one additional "quilt" object.

· Ensure that the "Enable Hierarchy Optimization" option is enabled on the last importer panel, especially when the Topology radio buttons are set to "Faces".

· Modify the tessellation quality sliders for lower quality by moving the sliders to the right. This will speed up the import process by creating far fewer triangles.

· Go back to your source 3D modeling program and strip down the size of the dataset prior to export to the ProE/Creo, IGES, STEP, etc. file. As our own general rule of thumb, add up the size of the files on disk and multiply by 10 - that is roughly how much memory may be needed to import all the files.

· For very large assemblies, do a "Shrink Wrap" operation on the data, remove wire harnesses and remove useless small components. This is something only recommended and done for at most 2 Okino customers per year, so it is very common when any MCAD file needs to be paired down.

· Write to Robert Lansdale (support@okino.com) and openly discuss your import speed problems. He has been dealing with these issues daily since 1988 and can help you get a handle on speeding up the import process, if necessary.

· How Can I Perform "Additional" Hierarchy & Parts Count Optimization?

It is always recommended that you keep the "Enable Hierarchy Optimization" option is enabled, as explained throughout this help file, especially when the Topology radio buttons are set to "Faces". This command will collapse all children objects inside a grouping folder to a single object, and remove extraneous hierarchy folders.

However, even though this processing is performed during the import phase, you can also perform it one or more additional times interactively. After import of the model into Okino's PolyTrans or NuGraf stand-alone programs, go to the "Win" menu of the "Selector Window" and execute the "Optimize Number of Objects and Folders" menu item. You can run this as many times as you wish, each time reducing the complexity of the parts hierarchy even further.

That same "Win" menu also provides options to remove small, large or specific parts from the scene, collapse the hierarchy, or remove "red folders" (master/instances) from the hierarchy.

Another method is to press the "Options…" button located to the right of the "Hierarchy Optimization" checkbox on the CAD importer’s wizard panel. Now change the "Number of times to runt this optimization process" to a number higher than 1. Please remember to reset or return this value to 1 for future imports.

· How do I fix imported models with "Cracks" between adjacent polygon faces?

If you are finding that holes or cracks appear between adjacent faces of the imported data, then use "Expert Mode" during an import process and set the "Topology Units" option to "Bodies" on the Expert Geometry Processing Options wizard panel. By selecting "Bodies" the Granite kernel is able to use equal surface subdivision on both sides of adjacent faces, thus eliminating the cracks. Your source CAD file must have been written as "BREP solids" and not independent NURBS surfaces.

· My model appears very small when imported into the destination program. Why?

The solution is to rescale the imported data to the size you desire using the drop-down scaling combo box shown on the Errors, Statistics & Scaling panel. You can also use this panel to match the source CAD units from the source 3D file to the destination units of your modeling program; for example, 3ds Max uses "inches" by default, Lightwave uses "centimeters" and Maya uses "meters".

See also:

Runtime Suggestions on How To Use the CAD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

Converter File Format Comparisons & Info

The File Import Process Using Okino’s PolyTrans or NuGraf

ProE/Creo "Instance Accelerator Files" and their Usage


Pro/Engineer Instance Accelerator Files and their Usage

ProE/Creo "Instance Accelerator Files", their Usage & "Family Tables".

Instance Accelerator Files

You can reduce much of the time required to retrieve an instance of a part or assembly from disk by saving the instance in a special file called an instance accelerator file. This must be done inside the ProE/Creo software. Each instance is saved in its own unique accelerator file, named instanceNAME.xpr for part instances and instanceNAME.xas for assembly instances (you will need to replace "NAME" with your own appropriate and unique name).

Accelerator files can be explicitly created by:

o Choosing "Open" in the Family Table, and then save the instance as a separate model file using File > Save or File > Save a Copy in the ProE/Creo menu bar.

o Save the entire model file using File > Save on the ProE/Creo menu bar (when the instance is being saved through a higher level object).

Inside the ProE/Creo software the saving instances of parts and assemblies is controlled by the Save Instance Accelerator variable. That variable can be set up or modified in two ways as follows:

By setting the configuration file option save_instance_accelerator. It can have the following values:

· none (default)—The system saves an instance only by saving the generic model and its Family Table.

· always—The system saves an accelerator file when the instance itself is explicitly saved (i.e., when you open an instance in a new ProE/Creo window using Open in the Family Table, and then save the instance as a separate model file using File > Save or File > Save a Copy in the ProE/Creo menu bar), and also when the instance is being saved through a higher level object (i.e., when you save the entire model file using File > Save on the ProE/Creo menu bar).

· explicit—The system saves an accelerator file only when the instance itself is explicitly saved (see the preceding paragraph for a description).

By choosing File > Instance Operations > Accelerator Options. The Instance Accelerator dialog box opens. The Using Options area contains the same three options as the configuration option, as described in the preceding procedure:

· None (default)

· Always

· Explicit

One of the three options is highlighted to reflect the most current setting that was loaded from a configuration file or selected previously using this dialog box.

Using the Instance Accelerator dialog box, you can also do the following:

· Create an instance accelerator file

· Save instances of parts and assemblies

· Update the generic and all instance accelerator files

· Delete invalid instance accelerator files

Loading non-Generic Instances via PTC Granite

Family table of instances in ProE/Creo files: if your part files use instances in family tables then you must explicitly create instance accelerator files to go along with those instances in the family tables. PTC Granite does not have the capability to load and create non-generic instances (such as those specified in a family table) because it would otherwise require the ProE/Creo software itself to create the new modified geometry. To solve this problem, users must create instance accelerator files for each non-generic instance in a family table.

About Family Tables

Family Tables are collections of parts (or assemblies or features) that are essentially similar, but deviate slightly in one or two aspects, such as size or detail features.

For example, wood screws come in various sizes, but they all look alike and perform the same function. Thus, it is useful to think of them as a family of parts. Parts in Family Tables are also known as table-driven parts.

Using Family Tables, you can:

· Create and store large numbers of objects simply and compactly

· Save time and effort by standardizing part generation

· Generate variations of a part from one part file without having to re-create and generate each one

· Create slight variations in parts without having to use relations to change the model

· Create a table of parts that can be saved to a print file and included in part catalogs

Family Tables promote the use of standardized components. They let you represent your actual part inventory in ProE/Creo. Moreover, families make it easy to interchange parts and subassemblies in an assembly, because instances from the same family are automatically interchangeable with each other.

Family Table Structure

Family Tables are essentially spreadsheets, consisting of columns and rows. They consist of the following three components:

o The base object (generic object or generic) on which all members of the family are based.

o Dimensions and parameters, feature numbers, user-defined feature names, and assembly member names that are selected to be table-driven (hereafter referred to as items).

o Names of all family members (instances) created by the table and the corresponding values for each of the table-driven items.

Rows contain instances of parts and their corresponding values; columns are used for items.

The column headings include the instance name, and the names of all of the dimensions, parameters, features, members, and groups that were selected for the table. Dimensions are listed by name (for example, d9) with the associated symbol name (if any) on the line below it (for example, depth). Parameters are listed by name (dim symbol). Features are listed by feature number (for example F107) with the associated feature type (for example [cut] ) or feature name on the line below it.

The generic model is in the first row in the table. The table entries belonging to the generic can be changed only by modifying the actual part, suppressing, or resuming features; you cannot change the generic model by editing its entries in the Family Tables.

Note: Family Table names are not case-sensitive. Therefore, any subsequent references to inserted names show them in uppercase letters.

For each instance, you can define whether a feature, parameter, or assembly name is used in the instance either by indicating whether it is present in the instance (Y or N) or by providing a numeric value (in the case of a dimension). All dimension cells must have a value, either a number or asterisk (*) to use the generic's value.

All aspects of the generic model that are not included in the Family Table automatically occur in each instance. For example, if the generic model has a parameter called Material with a value Steel, all instances will have the same parameter and value.

You can scroll horizontally through a Family Table to see additional information. The Instance Name column remains visible as you scroll.

Family Table functionality varies with your ProE/Creo module licenses.


The File Import Process Using Okino's PolyTrans Or NuGraf

Once PolyTrans/NuGraf and the PTC Granite DLLs have been installed on your machine, a typical import process proceeds as follows (the process is similar when importing directly into 3ds Max or Maya directly):

· From the NuGraf File/Import menu, or the PolyTrans Translate!/Import menu, select one of the importers which has the words "(via PTC Granite)" in its menu description. Such importers can include: ACIS SAT, IGES, PARASOLID, ProE/Creo native and STEP.

· The Granite import wizard appears inside the NuGraf or PolyTrans software, showing the Intro Panel. The "Next" button is pressed.

· The Beginner/Expert Mode panel appears next. This allows you to choose between further panels which are suitable for beginners, or for experts who want ultimate control over the import conversion process.

· If the beginner mode is selected, then the next panel will show the Beginner Precision options. This panel determines what type of geometry attributes are imported (vertices, normals, tangents or auto-computed normals) as well as how many polygons will be used to approximate the parametric solid surfaces of the source 3D file (the surface tolerance deviation). Clicking the "Next" button will advance to the last panel of this introduction (the Errors & Stats panel).

· If the expert mode is selected, then the next panel will show the NURBS surfaces and curves options. This panel allows you to choose between importing polygons or NURBS surfaces, and also allows you to optionally import independent NURBS curves. Almost all users of this importer will want to use the "Polygons" import radio button. Choosing the "NURBS Surface" radio button is only to be used by those users who need to re-export the model to a file format or program which can accept NURBS surfaces with uv-space trim curves. For example, that could be Maya, IGES, JT or OpenNURBS (Rhino).

· If the expert mode is selected, then the next panel will show the first of three Expert Tessellation Precision options. This panel controls the quality of the imported data. Normally most of the Granite supported file formats store objects as "solids" and these need to be meshed down to triangular meshes. The sliders on this panel control how closely the new triangle mesh will approximate the original 3D solids. Specifying higher quality will result in slower imports and more polygons. This panel will not be shown if NURBS Surfaces are chosen to be the base import primitive type.

· The next expert level panel will show the first of two Expert Geometry Processing options. This panel will allow you to further refine which polygon attributes are imported, as well as determine whether the objects should be "imported by body" (as one chunk) or "imported by face" (multiple chunks per object); each has its benefits and disadvantages. Importing by body will create many less objects, but you will not be able to easily assign materials to sub-sections of the object (as you could with by-face). Also, importing "by-body" in theory allows for better model quality because "crack free" tessellations can be performed. The term "quilts" shown on this panel refer to loose 3D surfaces found in the source CAD file which could not be connected up with other loose 3D surfaces to create a "solid" entity; you can either import these loose surfaces, or ignore them.

· The third of third expert level panel will show the Expert Geometry Processing # 2 options. This panel allows geometry processing functions to be applied to the original solids data deep inside the PTC Granite toolkit prior to the solids being converted to polygons. In most cases you will never want to change these options.

· The second last expert level panel will show the Material Import options panel. In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from the source CAD file so that they will render properly in the destination rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter.

· The last panel is the Errors, Statistics & Scaling. This presents some options to control how import converter errors are handled, and whether statistics should be displayed after the import process is completed. It also provides two drop-down combo boxes which allow the imported data to be scaled up in size or scaled down in size, as well as automatically scaled to match the source and destination scaling units. The "hierarchy optimization" checkbox allows Okino's "Part count and hierarchy optimization" system to be invoked on the imported data (not available for NURBS surface import mode); this can greatly reduce the number of objects in the scene, or the number of hierarchy nodes, depending on the structure of the source CAD file.

Once the wizard panels go away, the Granite kernel is invoked to parse the source CAD file. It will then attempt to stitch together the surface data (NURBS patches and other primitives) into unified "solids". At the last stage the Granite kernel will turn all solids and loose surfaces into a triangular mesh that is subsequently imported into Okino's core database.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

Converter File Format Comparisons & Info

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Intro Panel Options

This is the first panel which appears once one of the Granite import converters has been loaded.

Press either of the hyperlinks to start up this help file, or jump to the suggestions section.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Beginner/Expert Mode Options

This second panel determines whether subsequent panels will show simpler beginner options, or a variety of more complex options for expert users. Click on the telephone image for beginner mode, or the video camera for expert mode. We recommend the expert mode.

If you want to reset all of the import converter options to the default start-up values, then check-mark the "Reset import parameters before continuing" check box before pressing the "Next" button.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Beginner Precision Options

For beginners, this is one of the most important import converter panels. It determines "how much" data, how accurately the solid object data from the source file is converted to polygons, and how quickly the import process proceeds.

"Data Completeness" Slider

This slider determines which type of data is actually imported from the source file. Setting the slider all the way to the left will import the least attributes associated with the model, while setting the slider all the way to the right will import the most attributes possible. The increments on this slider are related to the options on the Expert Geometry Processing panel as follows:

Minimum - Import polygon data only. The imported data will appear faceted due to the lack of vertex normals. The data will also be "imported by body" which means that each solid entity (a body) will be imported as its own single object (rather than various sub-objects).

Some - Import polygons and vertex normals (smoothing info). This is useful is you want the imported objects to appear smooth, but you do not want to import uv texture coordinates for texture mapping or UV tangent vectors for bump mapping. Data is "imported by body" (see above).

Most - Import polygons, vertex normals and uv coordinates. This is useful is you want the imported objects to appear smooth, and to have default texture coordinates. The data will be "imported by face" which means that each solid will be imported as multiple sub-pieces, arranged in a hierarchical manner.

All - Import polygons, vertex normals, uv coordinates and tangent vectors. Same as above except that tangent vectors will be useful for adding bump mapping to objects via texture maps. Data is "imported by face" (see above).

"Surface Precision" Slider

Data inside a Granite imported file is represented as "solids" in many cases. When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles). This slider determines how accurately the original solid surfaces are approximated by polygons. If the slider is set all the way to the left, then few polygons will be used and the approximation will be poor; however, the import process will proceed rather quickly. If the slider is set all the way to the right then many polygons will be used and the approximation should be quite accurate; however, the import process speed may be slow due to the larger number of polygons that must be imported.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Expert NURBS Surfaces and Curves Options

Expert NURBS Surfaces & Curves Options

This panel controls whether independent NURBS curves will be imported, and whether the source 3D BREP objects will be imported either as polygons (preferred in all cases) or pure trimmed NURBS surfaces.

NOTES:

· Almost all users of this importer will want to use the "Polygons" import radio button. It will use the PTC Granite solids modeling kernel to tessellate the BREP solids model to a highly accurate and crack free model. This is basically what you are paying the money for and how you can be ensured a high quality model conversion.

· Choosing the "NURBS Surface" radio button is only to be used by those users who need to re-export the model to a file format or program which can accept NURBS surfaces with uv-space trim curves. For example, that could be Maya, IGES, JT, OpenNURBS (Rhino) or Softimage. You may also want to enable "Apply Data Healing Algorithms" checkbox for clean NURBS import (non-ProE/Creo files only).

· Not all user interface options are available when in NURBS mode. Those UI controls will be made hidden in NURBS mode.

NURBS Curves

Import Independent NURBS Curves

If this check box is enabled then any independent curves found in the file will be imported as NURBS curves. The Granite kernel will also attempt to convert non-NURBS curves (such as arcs, circles and polylines) into clean 3D NURBS curves prior to import. If construction lines or other curves in the original ProE/Creo file do not import, then they are simply not supported by the Granite kernel.

Import Only Composite Or Sketch Curves

If this check box is enabled then only curves marked as being "Composite" curves will be imported. Composite curves are those that are composed of 2 or more independent curves.

NURBS Surfaces

This appears to be a simple aspect of the user interface but in fact is one of the most complex aspects of the Granite importer.

Import NURBs Surfaces as: Polygons or Trimmed NURBS

These radio buttons determine what kind of geometry will be used to represent the imported data: either accurate tessellated polygons or raw trimmed NURBS surfaces with uv-space trim curves.

As the notes explain above, you will almost always want to import using the "Polygons" mode since that will create crack-free mesh models using the PTC Granite BREP tessellation engine.

Choosing "NURBS" will put the Granite importer into a special "GPI" importer mode. Each BREP "face" of an object will be imported as a uv-space trimmed NURBS surface object.

The upside of using this mode is that NURBS, not polygons, can be imported and then re-exported to Okino file formats which support trimmed NURBS natively.

The downside of importing NURBS are:

· Cracks can appear between the NURBS surfaces in the downstream destination program.

· It is up to the destination program to properly interpret and tessellate the NURBS surfaces. What is considered "accurate trimmed NURBS" in one program (ie. ProE/Creo) may not be considered error free or ideal in the downstream program due to tolerance and interpretation issues. This is particularly true with the uv-space trimming curves.

· Each BREP CAD "part" becomes 1 or more imported NURBS surface objects. Thus, a CAD part can create a large number of these NURBS surfaces, whereas a "Polygon" + "Bodies" import would create a succinct and small number of final objects, crack-free.

· CAD parts in the source file, which you would normally expect to be one continuous NURBS surface are often broken up by the PTC Granite kernel to be 2 or more NURBS surfaces. For example, a cone is broken up into 2 independent NURBS surfaces due to the singularity at the top of the cone.

Keep High Degree

If this option is enabled then high degree NURBS surfaces will be imported as-is, otherwise if this option is disabled then they will be reapproximated to lower degree cubic Bezier surfaces. In general you will want to keep this option disabled. If you import a model and find that the trim curves are linear (not cubic), or that the NURBS surfaces are low degree, then enable this option.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Expert Tessellation Precision Options

Data inside the PTC Granite kernel is represented as "solids" (NURBS surfaces). When importing these solids into Okino software they must be approximated by a mesh of connected polygons (triangles).

This panel controls how the PTC Granite kernel converts BREP solids data into a tessellated triangular mesh. The options control the "tolerance", or in other words, how closely the triangle mesh approximates the original solids data. This panel will not be shown if NURBS import mode is currently in effect.

In common, everyday usage of the importer, you would most likely perform one of the following operations:

1) Keep everything unchanged. The default slider values of 0.1% will most likely produce a good quality imported dataset.

2) If you’d like a higher quality dataset, with more polygons and less faceting, then you’d change the Planar and Curve sliders to 0.05% or even 0.01%. It would be rare if you needed to go any lower than these values. If you do, you can hand-enter lower numbers into the type-in boxes (such as 0.001%).

3) If you find that some holes in the imported model are not entirely round, then try enabling the "Angular" checkbox and lowering its slider to 50.0 or even 0.0.

4) If you wish to have the resulting triangular mesh have "squarish" triangles then enable the "U Steps" and "V Steps" checkboxes. The default values use 1/30th (3% of model size) as the step size which is the recommended value from PTC Corp. This will, however, increase the overall polygon count of the imported data.

Note: it has been seen that enabling/disabling the "Simplify Surfaces" option will change how the topology of the final polygons will be created. For example, importing a cone with this option enabled will create vertical, thin, sliver triangles, while disabling this option will allow more of a "squarish" triangle mesh to be created. In other words, the "U Steps" and "V Steps" options have better control when this "Simplify Surfaces" option is disabled.

Tolerances

Planar

This slider controls how smooth the final surface will appear.

Lower values will make the surface smoother but at the expense of a longer tessellation time and more resultant polygons.

This slider represents the maximum allowable distance (tolerance) between the true solids surface and that of the tessellated triangulated surface. The lower the value, the more the tessellated surface will approximate the real 3D surface. The value is measured as a percentage of each model’s bounding box "diagonal" dimension.

Curve

This slider controls how smooth curves will appear (such as trim holes or face boundaries).

Lower values will make curves smoother but at the expense of a longer tessellation time and more resultant polygons.

This slider represents the maximum allowable distance (tolerance) between a true curve and that of the tessellated curve. The value is measured as a percentage of each model’s bounding box "diagonal" dimension.

Angular

This slider also controls how smooth small details are in the model, such as tiny holes or fine fillets.

Lower values will make the surface smoother but at the expense of a longer tessellation time and more resultant polygons.

This slider represents the maximum allowable angle between any two adjacent triangles in the final mesh. The acceptable range is from 0.0 (very fine) to 100% (coarse).

NOTE: If you want to set a value higher or lower than allowable via the slider then just type in that number to the type-in box.

U and V ‘Steps’

These options allow the aspect ratio of the imported triangles to become "more square". They are both disabled by default only to keep the overall mesh density (polygon count) at a respectable limit.

UV step size specifies the "maximum surface domain of a triangle". This is best exemplified with the following image of a tessellated cylinder, with and without the "UV Steps" options enabled:

The cylinder on the right only has a single triangle connecting the top and bottom caps of the cylinder (many such triangles are shown around the circumference of the end caps). However, with the "UV Steps" option enabled the top and bottom faces of the cylinder now have 4 "steps" and thus 4 triangles connecting them.

Hence, this option causes the "U and V domain" of the underlying NURBS surface to be more finely subdivided during tessellation, depending upon the chosen "step size".

The sliders represent the desired "step size" along the U and V directions of the underlying NURBS surface. The values are measured as a percentage of each model’s bounding box "diagonal" dimension. The default values use 1/30th (3% of model size) as the step size which is the recommended value from PTC Corp.

Note: It has been seen that enabling/disabling the "Simplify Surfaces" option will change how the topology of the final polygons will be created and whether the "UV Steps" options affect the tessellation.

If the "Clamp maximum number of steps (for large models)" combo box option is chosen, then the internal Granite tessellation code will automatically clamp the UV-Step sizes so that the mesh tessellation will not "blow up" and create an unusually high number of polygons – this is the recommended default setting from PTC.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Expert Geometry Processing Options

This expert mode options panel provides control over specialized aspects of the import process.

The options that might be most interesting to users are the "Topology Units" (see below) and the "Import Quilts" (and/or "Make Quilts Hidden").

Optimize vertices to speed up import processing"

If this check box is enabled then all duplicated (redundant) vertices of the imported data will be deleted before any normals, uv coordinates or UV tangent vectors are queried from Granite. This will speed up the import process because redundant data queries will not have to be made. There is no reason to ever disable this option.

Normal Attribute Processing (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex normals are to be created for the imported polygon data.

-Skip- No vertex normals will be imported. The imported polygon data will not appear smooth when rendered.

Generate - A smoothing algorithm in the import converter will be enabled to automatically create vertex normals based on smoothing angle. This will create only an approximation of the real vertex normals from the source file. If this option is chosen then the "Smoothing Angle" text type-in box becomes enabled; higher values (near 90 degrees) will make your objects appear highly smoothed (no sharp corners) whereas lower values (around 15 to 20 degrees) will make your import objects appear more faceted, although smooth where they should be.

Import Only - The true vertex normals will be queried from the source CAD file one by one by way of the PTC Granite Kernel. This is much slower but produces more accurate results.

Import & Optimize - The same as "Import Only", but the vertex normals will also be optimized so that any redundant coordinates are deleted. There are some rare cases where you may want to use "Import Only" to speed up the overall process.

uv Texture Coordinates (Pop-Down List Box)

This pop-down list box determines, absolutely, how vertex uv texture coordinates are to be imported.

-Skip- No vertex uv texture coordinates will be imported. You will not be able to apply 2D bitmap textures to the imported objects without these uv texture coordinates.

Import Only - The true vertex uv texture coordinates will be queried from the source CAD file one by one.

Import & Optimize - The same as "Import Only", but the vertex uv texture coordinates will also be optimized so that any redundant coordinates are deleted.

UV Tangent Vectors (Pop-Down List Box)

This option is only available for the "Automation" import method and not the "Display List" import method.

This pop-down list box determines, absolutely, how vertex UV tangent vectors are to be imported from the source CAD file. These options override the vertex UV tangent vector import methods selected on the previous Expert Tessellation Options Panel:

-Skip- No vertex UV tangent vectors will be imported. You will not be able to apply 2D bitmap bump mapping textures to the imported objects without these tangent vectors.

Import Only - The true vertex UV tangent vectors will be queried from the PTC Granite Kernel one by one.

Import & Optimize - The same as "Import Only", but the vertex UV tangent vectors will also be optimized so that any redundant coordinates are deleted.

Topology Units: Bodies or Faces

Because Granite is a solid modeling package, internally it represents solids in "BREP" form (boundary representation). An object consists of a "body", which is made up of "shells" and each shell is made up of "faces". These faces are not to be confused with polygon faces of other programs. "Faces" are independent NURBS surfaces (patches).

If the "Bodies" option is chosen on this panel (which is always the default) then each major object will be imported as one mesh object and you will not be able to easily assign materials to sub-components of the imported object. This will produce the fastest and most efficient imports, with crack-free meshes.

If the "Faces" option is chosen on this panel then each major object will be imported as several sub-mesh objects, stored under one hierarchical parent folder (or "null object" as alternative lingo). Since the object is imported as several sub-objects, you may find it easier to assign materials. However, this method can ultimately result in a scene with a very large number of objects; in such cases you can reduce and optimize the number of objects by enabling the "Hierarchy Optimization" checkbox option on the Errors, Statistics & Scaling panel. If you find that no colors are assigned to the objects while using the "By Bodies" method, then revert to using the "By Faces" method as the colors may be assigned to the individual faces and not the bodies of the model.

** NOTE **

You may find that importing "By Body" produces better tessellation results and less "cracks" or holes between adjacent edges. This is because each adjacent "face" of the body is taken into account when the two faces are tessellated (so that no holes appear between faces). If you import "By Face" then holes or "cracks" may appear between adjacent faces.

Import Quilts, and Make Quilts Hidden

When the individual 3D surface entities (NURBS patches, spline surfaces, etc) are first read in the from the source CAD file they are turned into "quilts", as they are called by the Granite solids kernel. The various quilts are then connected together as much as possible. If some quilts end up forming a closed volume then the Granite kernel creates a "solid" BREP object and no longer keeps the corresponding "quilts". What remains after this stitching operation are loose quilts.

If this "Import Quilts" option is enabled then whatever quilts (loose surfaces) exist after the stitching operation will be imported as individual triangulated objects. If the option is disabled then all loose quilts will be ignored and not imported. If you find that the imported scene has extraneous parts of surfaces, then disable this option.

If the "Make Quilts Hidden" option is enabled then all loose quilts will be imported, but they will be tagged as being hidden in the scene.

In general this checkbox should be disabled for ProE/Creo file imports and enabled for all other types of import (ACIS, IGES, PARASOLID and STEP).

Flip Model so that 'Y' Axis is 'Up'

By default the data is imported so that the 'Y' up axis in the source CAD file becomes the 'Y' up axis in Okino software. If this checkbox is enabled, then the imported data will be reoriented so that the 'Z' axis in the source CAD file becomes the 'Y' Up axis in Okino software.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Expert Geometry Processing Options # 2

Expert Geometry Processing Options, Panel # 2

This expert mode options panel provides options which modify and/or process the imported surface and solids entities of the source CAD file, deep inside the Granite kernel, before the data is turned into a triangular mesh. It is not applicable for ProE/Creo file import.

Ignore Invisible Items

If this option is enabled then entities which are marked as "hidden" will not be imported into the current scene.

Apply Data Healing Algorithms

This will fix "problem boundary" cases and apply data healing algorithms to the source data. Adjacent NURBS surfaces (patches) will be attempted to be joined together.

** We have found that this option is particularly good to use when the NURBS import mode is currently in effect. It will help to fix any "bad" NURBS surfaces in the source file before they make it into the internal Okino NURBS engine.

NOTE: If "Apply Data Healing Algorithms" is enabled then you should also make sure to keep "Join Surface Gaps" enabled as well.

Join Surface Gaps

Models may have gaps between adjoining NURBS surfaces. Enabling this option will attempt to fix the gaps. The default is enabled.

Close 'Open uv-trims' With Linear Line Segment

If the importer encounters a surface with an open trimming boundary, it will attempt to close it with a straight line in UV space of the surface.

Simplify Surfaces (e.g. Replace Spline Surfaces with a Plane)

This option will attempt to simplify surfaces. For example, it might replace a spline surface with a plane if deviation is smaller than linear tolerance. The default is enabled.

Generate Log File, Output to the same source directory and filename as the input filename

When enabled, this option will allow a .log file to be output as the source CAD file is parsed and processed. The log file will also contain statistics about the number of geometric entities found in the file. The log file will be saved out to the same directory from which the source CAD file is located. It will also use the same filename but with a new ".log" file extension appended.

Numerical Accuracy Type

This is a super-rarely used option which may only be needed in specific data import cases.

For example, if you ever encounter a NURBS trimming oddity on a STEP file then change this combo box to use "Accuracy type from the imported file", or alternatively, just increase the mesh tessellation quality (move the "Planar" and "Curve" sliders to the left some more).

Background: CAD files most often include an "accuracy" value which defines the numerical tolerance that the original MCAD modeling program used in the process of creating the scene. For example, a tolerance value of 1e-12 would mean that any 2 points within a distance of 1e-12 units from each other should be considered a single point.

This combo box tells the Granite kernel software where it should obtain the "numerical tolerance accuracy value" for the imported data:

Accuracy type from the imported file

The numerical tolerance value will be extracted and used from the source file.

Relative accuracy type

This is a specialized internal mode used by the PTC Granite software. The default is "Relative accuracy". PTC has not provided a technical explanation of this mode but it is used for almost all file imports you’ll ever perform. The numerical tolerance value will be automatically computed internally within Granite.

Use Granite's default accuracy type

This is the default combo box option. It will cause Granite to use the "Relative" accuracy type except for ProE/Creo .neutral files for which it’ll use the "Accuracy type from the imported file".


Pro/Engineer Assembly File Processing Options

ProE/Creo Assembly File Processing Options

This expert mode options panel provides options which control the processing of assembly files and models when loading in from ProE/Creo native files (.asm and .prt). It is not applicable for non-native ProE/Creo file formats (such as Neutral files, ACIS, IGES, STEP and PARASOLID).

Import assembly cut features

If this option is enabled then "assembly cut features" will be applied to the models during loading. If disabled then no assembly cut will be applied.

NOTE: in some rare cases PTC Granite cannot load in models with unsupported assembly cuts. These assembly cuts may be from older versions of ProE/Creo software, or newer versions which had recently been corrected. In such cases the assembly, or sub-assembly, needs to be regenerated within the main ProE/Creo software.

Load facet data when instance accelerator files are not found

Family table of instances in ProE/Creo files: if your part files use instances in family tables then you must explicitly create instance accelerator files to go along with those instances in the family tables. The extension of those files are .xpr (part) and .xas (assembly).

If those files are missing then you can enable this checkbox to cause the alternative "facet representation" of the instances to be loaded. Ideally you would want to go and obtain the missing instance accelerator files.

Load generic models when accelerators not found

If this option is enabled then the generic model will be loaded, if and when an instance accelerator file is missing during the loading process. This may result in incorrectly defined files, since the wrong model is being used in the imported assembly. The "generic model" is the original, non-instanced baseline part object.

Both of these checkboxes cannot be enabled at the same time, so one will always be forcibly disabled.

NOTE: You may receive an "XinvalidArg" error message if this option is disabled and accelerator files are missing due to NULL file names internally within the Granite importer.

Lesser Used Options

Remove missing models from an assembly

If this option is enabled then missing model components will be removed from the loaded assembly. When enabled, the following 2 options must be disabled, otherwise a KXInvalidArg exception will occur.

Ignore missing models and continue

If this option is enabled then the loading process will continue even if some models cannot be located and loaded.

Ignore unauthorized (protected) models

If this option is enabled then the loading process will continue even if some models are un-authorized (which are protected and allowed to open only with some specific permissions, such as DRM protection).

Keep failed assemblies

If this option is enabled then the Granite importer framework will return a valid pointer to the top-level assembly even if all sub-assemblies failed during import.

Failed assemblies: Skip or Fail

These radio buttons determine the handling of failed assembly cut features.

"Skip" will cause a failed assembly cut feature to be skipped over.

"Fail" will cause a failed assembly cut feature to fail (abort) its operation.


Material Import Options

In the fashion of many Okino import and export converters, this is a key options panel which allows you to modify the imported material properties from the source CAD file so that they will render properly in the destination rendering program. By pressing the "New" or "Details" button, the Material Tweaks sub-dialog box will appear; this dialog box provides a wealth of methods to have the imported material characteristics automatically modified to your liking. Multiple "tweak methods" can be user defined and saved between invocations of this import converter. The default action is to not modify any imported material characteristics.

Import Method (Pop-Down List Box)

By default, three "material import processing" methods have been provided for you by clicking on the pop-down list box. You are also free to define your own methods by pressing the "New" button on the panel which will call up the Material Tweaks sub-dialog box:

Do Not Import Material Properties - No material properties will be imported at all.

Preserve Numerical Values - All materials will be imported from the source CAD file without any change or tweaking.

Preserve Appearance (Recommended) - The material shading coefficients will be set to the following values, ensuring that the model should look ok when rendered:

· Diffuse shading coefficient = 0.4

· Ambient shading coefficient = 0.3

· Specular shading coefficient = 0.7

· Highlight value = 0.12 (0 = wide highlight, 1.0 = narrow highlight)

· Emission (luminous) shading coefficient = 0

· Opacity (inverse of transparency) = 1.0 (fully opaque)

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Material Tweak Options

This sub-dialog box provides ultimate control over how imported material properties should be modified so that the imported model can be rendered nicely in a photo-realistic rendering program. All too often the imported model appears "too ambient" or "too diffuse", resulting in rendered images that are washed out or with no gradual shading effects visible. By default you should use the "Preserve Appearance" pre-defined import method.

First, to add a new material processing method, press the "New" button on the Material Import panel. This will cause the sub-dialog box to appear in which you can set your custom material import processing options.

As an explanation of the various shading parameters listed on the sub-dialog box:

Diffuse: This controls the amount of color reflected from an object based on the direct light shining on it. A good default value is 0.4.

Ambient: This controls the amount of color reflected from an object based on the ambient light in a scene. A good default value is 0.1 through to 0.3.

Specular: This controls the intensity of the highlight on an object. A good default value is 0.7.

Highlight: This controls the width of the specular highlight on an object (0 = wide, 1.0 = very narrow). A good default value is 0.12.

Emission (luminous): This controls how much color is added to an object, irrespective of any light which shines on it (the higher the value, the more the object will appear to glow). In general you should keep this value at 0.

Opacity: This is the inverse of transparency. 0.0 will make the object fully transparent, while at 1.0 the object will be fully opaque.

For each material property, several actions can be performed on it during the import from the source CAD file. Two sets of actions are provided, that which is performed when the diffuse color values is being imported and those which are performed when all other parameters other than diffuse are being imported.

The actions taken when importing the diffuse color value are described as follows:

- Skip - : The diffuse color value is not imported (no color change is made).

Use Default Coefficient: This action imports the diffuse color with no change made at all, but the diffuse shading coefficient for the color will be set to a "pleasant" value resulting in 3D scenes which render "photo-realistically" (in other words, without harsh or overly bright colors). This coefficient typically ranges from 0.3 through to 0.5. The "coefficient" mentioned here is the same as the "Shading Coefficients" on the "Color" surface attribute editor in Okino’s NuGraf Rendering System software.

Set Coefficient To: This behaves the same as "Use Default Coefficient" except that the diffuse shading coefficient for the diffuse color is set to a user specified value. Let’s assume you set this shading coefficient to 1.0 (the worse case); this would result in a rendered scene which was over saturated in diffuse color. To circumvent this problem (as is done in all 3D rendering packages), we "attenuate" the diffuse color by a specific percentage so that it won’t saturate the final rendered image when the shading is done.

Normalize Color and Coefficient: This is a hybrid approach which tries to automatically "guess" at proper diffuse shading coefficient values using the raw diffuse color imported from the source CAD file. As mentioned, this shading coefficient is needed to create nice looking (nicely shaded) images in a photo-realistic rendering program. If this drop-down box option is chosen, then the diffuse shading coefficient will be derived directly from the relative intensity of the imported diffuse color. For example, if the imported diffuse color is (0.4, 0, 0), which is 40% of full-bright red, then the diffuse shading coefficient will be set to 0.4 and the diffuse color will be modified to be (1, 0, 0). When the new color (1,0,0) and the new shading coefficient (0.4) are multiplied together, it results in the original color imported from the source CAD file (0.4, 0, 0). In general you may wish to use the "Use Default Coefficient" option to get good rendered results.

The actions taken when importing all parameters other than "diffuse" are described as follows (highlight value and opacity):

- Skip - : The material parameter is ignored during import.

Import Unchanged: The material parameter is imported as is, with no change.

Unconditionally Set To: The material parameter is not imported but rather it is set to the numeric value on the dialog box.

Import and Crop by: The material parameter is imported and remains unchanged if it is less than the numeric value on the dialog box. If it is greater, then the imported value will be clamped to be no greater than the numeric value on the dialog box.

Import and Scale by: The material parameter is imported and scaled by the numeric value on the dialog box.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Automatic units matching, post-processing and meta-data

Automatic Units Matching, Hierarchy Optimization & Meta-Data

One of the primary uses of this panel is to set up the "Units matching". Data from the source CAD file will most likely have an assigned "units of measurement" for all of its data, such as "meters". However, the destination 3D program may not be using meters as its default measurement units. For example, 3ds Max uses "inches" by default, Lightwave uses "cm" and Maya uses "meters". The combo boxes on this panel allow the measurement units to be matched, as well as allowing additional scaling to be applied to the imported geometry data.

Hierarchy Optimization

This is absolutely the most important option to keep enabled in most cases. It can make all the difference between importing a CAD model quickly, with little memory usage and the fewest objects verse importing it slowly, with all memory being used up, and with an excessive number of objects. This is particularly true if the Topology radio buttons are set to "Faces".

This option will collapse hierarchies of hundreds of face parts into many fewer parts, making the import of large and complex assemblies possible for programs such as 3ds Max, Maya, Cinema-4D, Softimage, Lightwave and others (non-CAD programs which suffer in terms of performance for assemblies with large numbers of objects). The documentation for the "Hierarchy Optimization" option can be viewed by pressing the "Options…" button and then the "Help" button on the optimizer's dialog box.

Primary suggestion: do not worry about all of these options! Just use the defaults in any and all cases.

Data Scale

"Units conversion" is often an important aspect of importing CAD files. People who create 3D models in a modeling package will do so using a specific units system, such as meters or feet. However, when these models are imported into another 3D package that uses a different default units system (such as Lightwave which uses centimeters), a "units conversion" operation needs to occur (the imported model geometry needs to be rescaled).

This import panel determines what will be done when the units defined in the source CAD file does not match current internal system units. If the units do not match, the Granite importer will rescale the imported geometry based on the ratio between the source CAD file's units and the internal system units.

Unit of Measurement

You need to set this combo box to the measurement units system in effect for your destination 3D program. For example, set it to centimeters for Lightwave, inches for 3ds Max, centimeters for Maya, etc.

If you are importing into the Okino PolyTrans or NuGraf programs then you can either set the destination units measurement system via this combo box or set the combo box to "Current System" and then set the measurement system inside the main PolyTrans/NuGraf program (Edit/Preferences/Startup Preferences/Other/System Units).

Ignored | No units; never do any geometry scaling
Current System | Scale data to match current internal Okino units
Use Document | Set Okino units to the file’s units. No scaling done
Microinches | 1e-6 inches
Mils | 1e-3 inches
Inches | 2.54 centimeters
Feet | 12 inches
Yards | 36 inches
Miles | 1.6 kilometers
Microns | 1e-6 meters
Millimeters | 1e-3 meters
Centimeters | 1e-2 meters
Decimeters | 1e-1 meters
Meters | 3.28 feet
Kilometers | 0.62 mile
Custom | Custom units are in effect

If the "Custom" option is chosen then the numeric value contained in the "Additional scaling to apply" edit control defines the "units per meter" scale factor for a custom unit system. For example, if you were to enter "0.62" into the type-in box then this would be equivalent to the "Kilometers" units measurement system.

Additional Scaling to Apply (Combo Box)

This drop-down combo box allows imported geometry to be scaled up or down in size by units of 10, 100 or 1000 times. You are free to enter your own scaling factor into the type-in portion of the combo box if you wish (such as "5000"). If you created your model using "millimeters", for example, then the model will appear about 1000 times too small when imported into the destination program. The solution is to select a scaling option on this wizard panel appropriate for the size of the data as it appears in the source 3D modeler. For example, if you model in millimeters within the source 3D modeler then you will want to scale up by 1000 units so that the imported model will not look tiny.

NOTE: If the "Unit of Measurement" combo box is set to "Custom" then the "Additional scaling to apply" edit control defines the "units per meter" scale factor and not an absolute scaling factor.

Ignore Component Units

Rarely there comes about cases where an assembly contains a mixture of different units on its sub-assembly and part nodes. If a sub-assembly or part imports with the wrong scaling then toggle this checkbox on or off.

Import Meta-Data

If this option is enabled meta-data will be imported as strings and numerical values. Meta data will be placed on either Okino instances or on the object definitions. The meta data can be viewed in Okino software via the "Instance Attributes" dialog box, "Meta Data" tab.

Merge Triangles To Quads, Max Angle = #

PTC’s ProE/Creo, and all top-6 MCAD programs since the invention of NURBS in the 1980’s, always output triangular meshes and not quad meshes. This is because quads cannot accurately represent the curvature of NURBS surfaces.

This option is a post-processing step that merges triangles back to quadrilateral polygons (4 sided polygons). The number of vertices remain the same but the overall number of polygons are reduced.

If this option is enabled (checkmarked) then an algorithm will be invoked which merges multiple polygons into quads. If two adjacent triangles are nearly co-planar then they will be turned into a quadrilateral. The vertices of the adjacent edges must be welded together (shared) for this operation to proceed properly.

The test for co-planar polygons (polygons which are almost on the same plane as each other) is determined by the "Max angle" type-in box. This value is measured in degrees. Values near 0 will require that adjacent polygons be very much co-planar with each other, while higher values will allow polygons that meet at an angle to be considered. For example, if you have a curved object made of triangles then try setting the angle to 4 to 7 degrees. Higher values will allow more polygons to be merged.

NOTE: you can also apply this merging algorithm via the "Polygon Processing" functionality found in the stand-alone Okino software. On that dialog box you would invoke the "Merge Co-Planar Polygons into larger polygons" function. That alternative version also provides some more controls over whether vertex normals, vertex colors and vertex uv’s are to be taken into account (they are all taken into account when invoked via the polygon reduction system).

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


Errors and Statistics

Statistics, Errors & Finish

This simple, last panel of the wizard allows control over error reporting and statistics output.

Runtime Import Options

Tolerate File Integrity Errors

If this option is enabled then the converter will not stop if it receives unexpected data as a result of a data query to the Granite kernel; in this case the import converter will just skip over that element and continue importing.

Report Statistics About the Imported File

If this check box is enabled then statistics will be reported after the data has been imported.

See also:

Runtime Suggestions on How To Use the CD Importers Properly & Efficiently

Visual Snapshot Index of Each Import Converter Panel

The File Import Process Using Okino’s PolyTrans or NuGraf

Important Runtime Information, How-To’s, and Execution Notes

ProE/Creo "Instance Accelerator Files" and their Usage


AFX_HIDP_default

No Help Available

No help is available for this message box.

<< If you wish to author help specific to each message box prompt, then remove the AFX_HIDP_xxx values from the [ALIAS] section of your .HPJ file, and author a topic for each AFX_HIDP_xxx value. For example, AFX_HIDP_INVALID_FILENAME is the help topic for the Invalid Filename message box. >>


HID_HELP


HID_HT_NOWHERE

No Help Available

No help is available for this area of the window.


HID_WIZBACK


HID_WIZFINISH


HID_WIZNEXT


HIDC_ANGLE

This value controls the smoothing criterion used when normals are being generated (as opposed to being queried from the server). It is based on the angle between abutting polygons; common smoothed vertex normals will be computed if the angle between their geometric surface normals is less than the angle specified.

Defaults to 45 degrees. Increase this value if the imported object appear to have overly rough surface. Decrease this value if the surface appears to be overly smoothed.


HIDC_BANNER


HIDC_BEGINNER


HIDC_BODIES


HIDC_ERROR_TORERANT


HIDC_EXPERT


HIDC_FACES


HIDC_FLIP_Y_UP

If this option is enabled then the model will be rotated so that its Up axis is aligned with the positive Y-axis instead of the positive Z-axis.


HIDC_NORMALS


HIDC_OPEN_CURRENT


HIDC_OPEN_FILE


HIDC_OPTIMIZE_VERTICES


HIDC_REPORT_STATS

If this checkbox is enabled then the import converter will print out the number of objects, polygons, normals, texture coordinates, tangent vectors and surfaces that were parsed from the SAT file.


HIDC_RESET_DEFAULT


HIDC_TANGENTS

If this checkbox is enabled then the import converter will import proper tangent vectors for each triangle vertex. Tangent vectors are necessary if bump map texture image is to be applied to the object at some time in the future.


HIDC_UV

If this checkbox is enabled then the import converter will import proper texture (u,v) coordinates for each triangle vertex. Texture coordinates are necessary if a bitmap texture image is to be applied to the object at some time in the future


HIDP_INVALID_PATH

Invalid Path

HIDP_INVALID_PATH